Ruby - Bug #20262

Regex mismatch between Ruby 3.2.2 and 3.3.0
02/13/2024 06:28 AM - weilandia (Nick Weiland)

Status: Closed
Priority: Normal
Assignee:

Target version:

ruby -v: 3.3.0 Backport: 3.0: UNKNOWN, 3.1: UNKNOWN, 3.2:

UNKNOWN, 3.3: UNKNOWN

Description
This might be a duplicate of https:/bugs.ruby-lang.org/issues/20098, but | cannot make it match with the backref so maybe not.

Below example matches in 3.2.2 but not in 3.3.0

str = "——————————— abcdefg--———-——————- #3895912"
re = /() \1\b\w* [a-zA-Z2-1*\d+[\w-]1{3, }\w+\b/
re.match? (str)

History

#1 - 02/13/2024 06:28 AM - weilandia (Nick Weiland)

| accidentally left the "()\1" in the original post, but it should not be there and | don't see a way to change it. The code example should be:

str = "————————— abcdefg-———————————- #3895912"
re = /\b\w*[a-zA-Z2-]*\d+[\w—]{3, }\w+\b/
re.match? (str)

#2 - 04/24/2024 08:12 AM - mame (Yusuke Endoh)
- Status changed from Open to Closed

Maybe the same issue as https://bugs.ruby-lang.org/issues/20083. Fixed at 3.3.1.

$ RBENV_VERSION=3.2.2 ruby -e 'str = "-———-—--———— abcdefg-——————-——-—— #3895912"
re = /\b\w*[a-zA-Z2-]*\d+[\w—] {3, }\w+\b/

p re.match? (str)'

true

$ RBENV_VERSION=3.3.0 ruby -e 'str = "—-——————————— abcdefg-————-——————- #3895912"
re = /\b\w*[a-zA-Z-]1*\d+[\w-] {3, }\w+\b/

p re.match?(str)"'

false

$ RBENV_VERSION=3.3.1 ruby -e 'str = "-—----n—~ abcdefg-————-—----—~ #3895912"
re = /\b\w*[a-zA-Z-]*\d+[\w=]{3, }\w+\b/

p re.match? (str)'

true
